// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once

#include "ISCW_UGeneralProjectSettings.h"
#include "SCW_UObject.h"

class UGeneralProjectSettings;

namespace Sourcify
{
	class SCW_UGeneralProjectSettings : public SCW_UObject, public virtual ISCW_UGeneralProjectSettings
	{
	public:
		SCW_UGeneralProjectSettings(UGeneralProjectSettings* InGeneralProjectSettings);

		wstring GetCopyrightNotice() const override;

		UGeneralProjectSettings* ToUGeneralProjectSettings() const;

		ISCW_UGeneralProjectSettingsPtr ToUGeneralProjectSettingsPtr() override;
		ISCW_UGeneralProjectSettingsConstPtr ToUGeneralProjectSettingsPtr() const override;

	protected:
		UGeneralProjectSettings* GeneralProjectSettings;
	};
} // namespace Sourcify